> ## Documentation Index
> Fetch the complete documentation index at: https://developers.phrase.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Create job from connector asynchronous download task

> 
Creates the job in project specified by path param projectUid. Source file is defined by downloadTaskId parameter. That is value of finished download async task
[Connector - Download file (async)](../connector/download-file-async).

Please supply job metadata in body.

Accepted metadata:

  - `targetLangs` - **required**
  - `due` - ISO 8601
  - `workflowSettings` - project with workflow - see examples bellow
  - `assignments` - project without workflows - see examples bellow
  - `importSettings` - re-usable import settings - see [Create import settings](../import-settings/create-import-settings)
  - `useProjectFileImportSettings` - mutually exclusive with importSettings
  - `callbackUrl` - consumer callback
  - `path` - original destination directory
  - `preTranslate` - set pre translate job after import
  - `semanticMarkup` - set semantic markup processing after import when enabled for organization
  - `xmlAssistantProfile` - apply XML import settings defined using XML assistant

Create job simple (without workflow steps, without assignments):
```
{
  "targetLangs": [
    "cs_cz",
    "es_es"
  ]
}
```

Create and assign job in project without workflow step:
```
{
  "targetLangs": [
    "cs_cz"
  ],
  "callbackUrl": "https://my-shiny-service.com/consumeCallback",
  "importSettings": {
    "uid": "abcd123"
  },
  "due": "2007-12-03T10:15:30.00Z",
  "path": "destination directory",
  "assignments": [
    {
      "targetLang": "cs_cz",
      "providers": [
        {
          "id": "4321",
          "type": "USER"
        }
      ]
    }
  ],
  "notifyProvider": {
    "organizationEmailTemplate": {
      "id": "39"
    },
    "notificationIntervalInMinutes": "10"
  }
}
```

Create and assign job in project with workflow step:
```
{
  "targetLangs": [
    "de"
  ],
  "useProjectFileImportSettings": "true",
  "workflowSettings": [
    {
      "id": "64",
      "due": "2007-12-03T10:15:30.00Z",
      "assignments": [
        {
          "targetLang": "de",
          "providers": [
            {
              "id": "3",
              "type": "VENDOR"
            }
          ]
        }
      ],
      "notifyProvider": {
        "organizationEmailTemplate": {
          "id": "39"
        },
        "notificationIntervalInMinutes": "10"
      }
    }
  ]
}
```
    



## OpenAPI

````yaml /openapi/phrase-tms-latest.json post /api2/v1/projects/{projectUid}/jobs/connectorTask
openapi: 3.0.0
info:
  description: |-
    Welcome to Phrase's TMS API documentation. 

     Please visit our [help center](https://support.phrase.com/hc/en-us/sections/5709662083612) for more information about the APIs. 

     If you have any questions, please contact [Support](https://support.phrase.com/hc/requests/new). 

     Please, include the `User-Agent` header with the name of your application or project. It might be a good idea to include some sort of contact information as well, so that we can get in touch if necessary. Examples of excellent `User-Agent` headers:
     > User-Agent: Example mobile app (example@phrase.com) <br/> User-Agent: ACME Inc Java 1.8 Client (http://acmeinc.com/contact)
  version: Latest
  title: Phrase TMS API
servers:
  - url: https://cloud.memsource.com/web
security:
  - ApiToken: []
  - OAuth2: []
tags:
  - name: Additional Workflow Step
  - name: Analysis
  - name: Async Request
  - name: Authentication
  - name: Automations
  - name: Bilingual File
  - name: Business Unit
  - name: Buyer
  - name: Client
  - name: Connector
  - name: Conversations
  - name: Cost Center
  - name: Custom Fields
  - name: Custom File Type
  - name: Domain
  - name: Due Date Scheme
  - name: Email Template
  - name: File
  - name: Glossary
  - name: Import settings
  - name: Job
  - name: Language AI
  - name: Language Assets
  - name: Language Quality Assessment
  - name: Machine Translation
  - name: Machine Translation Settings
  - name: Mapping
  - name: Net Rate Scheme
  - name: Notifications
  - name: Price List
  - name: Project
  - name: Project Reference File
  - name: Project Template
  - name: Provider
  - name: Quality Assurance
  - name: Quality Profile
  - name: Quote
  - name: SCIM
  - name: Segment
  - name: Segmentation Rules
  - name: Service
  - name: Spell Check
  - name: SubDomain
  - name: Supported Languages
  - name: Term Base
  - name: Translation
  - name: Translation Memory
  - name: User
  - name: Vendor
  - name: Webhook
  - name: Workflow Step
  - name: Workflow changes
  - name: XML Assistant
paths:
  /api2/v1/projects/{projectUid}/jobs/connectorTask:
    post:
      tags:
        - Job
      summary: Create job from connector asynchronous download task
      description: >-

        Creates the job in project specified by path param projectUid. Source
        file is defined by downloadTaskId parameter. That is value of finished
        download async task

        [Connector - Download file (async)](../connector/download-file-async).


        Please supply job metadata in body.


        Accepted metadata:

          - `targetLangs` - **required**
          - `due` - ISO 8601
          - `workflowSettings` - project with workflow - see examples bellow
          - `assignments` - project without workflows - see examples bellow
          - `importSettings` - re-usable import settings - see [Create import settings](../import-settings/create-import-settings)
          - `useProjectFileImportSettings` - mutually exclusive with importSettings
          - `callbackUrl` - consumer callback
          - `path` - original destination directory
          - `preTranslate` - set pre translate job after import
          - `semanticMarkup` - set semantic markup processing after import when enabled for organization
          - `xmlAssistantProfile` - apply XML import settings defined using XML assistant

        Create job simple (without workflow steps, without assignments):

        ```

        {
          "targetLangs": [
            "cs_cz",
            "es_es"
          ]
        }

        ```


        Create and assign job in project without workflow step:

        ```

        {
          "targetLangs": [
            "cs_cz"
          ],
          "callbackUrl": "https://my-shiny-service.com/consumeCallback",
          "importSettings": {
            "uid": "abcd123"
          },
          "due": "2007-12-03T10:15:30.00Z",
          "path": "destination directory",
          "assignments": [
            {
              "targetLang": "cs_cz",
              "providers": [
                {
                  "id": "4321",
                  "type": "USER"
                }
              ]
            }
          ],
          "notifyProvider": {
            "organizationEmailTemplate": {
              "id": "39"
            },
            "notificationIntervalInMinutes": "10"
          }
        }

        ```


        Create and assign job in project with workflow step:

        ```

        {
          "targetLangs": [
            "de"
          ],
          "useProjectFileImportSettings": "true",
          "workflowSettings": [
            {
              "id": "64",
              "due": "2007-12-03T10:15:30.00Z",
              "assignments": [
                {
                  "targetLang": "de",
                  "providers": [
                    {
                      "id": "3",
                      "type": "VENDOR"
                    }
                  ]
                }
              ],
              "notifyProvider": {
                "organizationEmailTemplate": {
                  "id": "39"
                },
                "notificationIntervalInMinutes": "10"
              }
            }
          ]
        }

        ```
            
      operationId: createJobFromAsyncDownloadTask
      parameters:
        - name: projectUid
          in: path
          required: true
          schema:
            type: string
        - name: downloadTaskId
          in: query
          required: false
          schema:
            type: string
        - name: continuous
          in: query
          required: false
          schema:
            type: boolean
            default: false
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/JobCreateRequestDtoV1'
      responses:
        '201':
          description: Created
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/JobListDtoV1'
        '400':
          description: Bad request
        '401':
          description: Not authorized
        '403':
          description: Forbidden
        '404':
          description: Resource not found
        '405':
          description: Method not allowed
        '408':
          description: Timeout
        '410':
          description: Gone
        '415':
          description: Unsupported media type
        '429':
          description: Too many requests
        '500':
          description: Internal server error
        '501':
          description: Not implemented
components:
  schemas:
    JobCreateRequestDtoV1:
      type: object
      required:
        - targetLangs
      properties:
        assignments:
          type: array
          description: >-
            only use for projects without workflows; otherwise specify in the
            workflowSettings object
          items:
            $ref: '#/components/schemas/ProvidersPerLanguage'
        callbackUrl:
          type: string
        due:
          type: string
          format: date-time
          description: >-
            only use for projects without workflows; otherwise specify in the
            workflowSettings object. Use ISO 8601 date format.
        importSettings:
          $ref: '#/components/schemas/UidReference'
        jobPreviewPackageFileUidRef:
          $ref: '#/components/schemas/UidReference'
        notifyProvider:
          $ref: '#/components/schemas/NotifyProviderDtoV1'
        path:
          type: string
          minLength: 0
          maxLength: 255
        preTranslate:
          type: boolean
        remoteFile:
          $ref: '#/components/schemas/JobCreateRemoteFileDtoV1'
        semanticMarkup:
          type: boolean
        targetLangs:
          type: array
          items:
            type: string
        useProjectFileImportSettings:
          type: boolean
          description: 'Default: false'
        workflowSettings:
          type: array
          items:
            $ref: '#/components/schemas/JobCreateRequestDtoWorkflowStepConfiguration'
        xmlAssistantProfile:
          $ref: '#/components/schemas/UidReference'
    JobListDtoV1:
      type: object
      properties:
        asyncRequest:
          $ref: '#/components/schemas/AsyncRequestReferenceV1'
        jobs:
          type: array
          items:
            $ref: '#/components/schemas/JobPartReferenceV1'
        unsupportedFiles:
          type: array
          items:
            type: string
        warnings:
          type: array
          items:
            $ref: '#/components/schemas/JobListWarningDtoV1'
    ProvidersPerLanguage:
      type: object
      properties:
        assignedUsers:
          type: array
          items:
            $ref: '#/components/schemas/User'
        providers:
          type: array
          items:
            $ref: '#/components/schemas/ProviderReferenceV1'
        targetLang:
          type: string
    UidReference:
      type: object
      required:
        - uid
      properties:
        uid:
          type: string
    NotifyProviderDtoV1:
      type: object
      required:
        - organizationEmailTemplate
      properties:
        notificationIntervalInMinutes:
          type: integer
          format: int32
          minimum: 0
          maximum: 1440
        organizationEmailTemplate:
          $ref: '#/components/schemas/IdReference'
    JobCreateRemoteFileDtoV1:
      type: object
      required:
        - connectorToken
        - remoteFileName
      properties:
        connectorToken:
          type: string
        continuous:
          type: boolean
        remoteFileName:
          type: string
        remoteFileNameRegex:
          type: boolean
        remoteFolder:
          type: string
    JobCreateRequestDtoWorkflowStepConfiguration:
      type: object
      required:
        - assignments
      properties:
        assignments:
          type: array
          items:
            $ref: '#/components/schemas/ProvidersPerLanguage'
        due:
          type: string
          format: date-time
          description: Use ISO 8601 date format.
        id:
          type: string
        notifyProvider:
          $ref: '#/components/schemas/NotifyProviderDtoV1'
    AsyncRequestReferenceV1:
      type: object
      properties:
        action:
          type: string
          enum:
            - PRE_ANALYSE
            - POST_ANALYSE
            - CONTINUOUS_PRE_ANALYSE
            - CONTINUOUS_POST_ANALYSE
            - COMPARE_ANALYSE
            - PARENT_ANALYSE
            - PRE_TRANSLATE
            - ASYNC_TRANSLATE
            - IMPORT_JOB
            - IMPORT_FILE
            - ALIGN
            - EXPORT_TMX_BY_QUERY
            - EXPORT_TMX
            - IMPORT_TMX
            - IMPORT_MXLF_INTO_TM
            - IMPORT_TBX
            - IMPORT_TBX_TB3
            - INSERT_INTO_TM
            - DELETE_TM
            - CLEAR_TM
            - QA
            - QA_V3
            - UPDATE_CONTINUOUS_JOB
            - UPDATE_SOURCE
            - UPDATE_TARGET
            - EXTRACT_CLEANED_TMS
            - GLOSSARY_PUT
            - GLOSSARY_DELETE
            - ASYNC_TRANSLATE_VERIFY
            - CREATE_PROJECT
            - EXPORT_COMPLETE_FILE
            - IMPORT_ANNOTATIONS
            - FILE_FLOW_CONVERTER_IMPORT
            - FILE_FLOW_MT_PRETRANSLATE
            - FILE_FLOW_QUALITY_ESTIMATION
            - AUTO_LQA
            - ADOPT_SEGMENT_DATA
            - ADOPT_SEGMENT_SET_DATA
            - QP_EVALUATION
        dateCreated:
          type: string
          format: date-time
        id:
          type: string
    JobPartReferenceV1:
      type: object
      properties:
        continuous:
          type: boolean
        dateCreated:
          type: string
          format: date-time
        dateDue:
          type: string
          format: date-time
        filename:
          type: string
        imported:
          type: boolean
        jobAssignedEmailTemplate:
          $ref: '#/components/schemas/ObjectReference'
        notificationIntervalInMinutes:
          type: integer
          format: int32
        providers:
          type: array
          items:
            $ref: '#/components/schemas/ProviderReferenceV1'
        sourceFileUid:
          type: string
        status:
          type: string
          enum:
            - NEW
            - ACCEPTED
            - DECLINED
            - REJECTED
            - DELIVERED
            - EMAILED
            - COMPLETED
            - CANCELLED
        targetLang:
          type: string
        uid:
          type: string
        updateSourceDate:
          type: string
          format: date-time
        workflowLevel:
          type: integer
          format: int32
        workflowStep:
          $ref: '#/components/schemas/WorkflowStepReferenceV1'
    JobListWarningDtoV1:
      type: object
      properties:
        domain:
          type: string
          enum:
            - STYLEGUIDE
        jobPartIds:
          type: array
          items:
            type: string
        message:
          type: string
    User:
      type: object
      required:
        - id
      properties:
        id:
          type: integer
          format: int64
    ProviderReferenceV1:
      type: object
      required:
        - type
      discriminator:
        propertyName: type
      properties:
        id:
          type: string
        type:
          type: string
        uid:
          type: string
          readOnly: true
    IdReference:
      type: object
      required:
        - id
      properties:
        id:
          type: string
    ObjectReference:
      type: object
    WorkflowStepReferenceV1:
      type: object
      properties:
        id:
          type: string
        lqaEnabled:
          type: boolean
        name:
          type: string
        order:
          type: integer
          format: int32
        uid:
          type: string
  securitySchemes:
    ApiToken:
      description: >-
        Get a token from `auth/login` [endpoint](#operation/login) and then pass
        it in the `Authorization` HTTP header in every subsequent API call. For
        more information visit our [help
        center](https://support.phrase.com/hc/en-us/articles/5709662181404-API-Authentication-TMS-#token-0-0).
      type: apiKey
      name: Authorization
      in: header
    OAuth2:
      description: >-
        A standard OAuth 2.0 authorization code flow. For more information visit
        our [help
        center](https://support.phrase.com/hc/en-us/articles/5709662181404-API-Authentication-TMS-#oauth-2-0-0-1).
      type: oauth2
      flows:
        authorizationCode:
          authorizationUrl: https://cloud.memsource.com/web/oauth/authorize
          tokenUrl: https://cloud.memsource.com/web/oauth/token
          scopes: {}

````